#!/usr/bin/env python
# this code is an extension of the code of 
# http://nbviewer.ipython.org/gist/harrism/f5707335f40af9463c43 
# Peter Beerli
import numpy as np
from timeit import default_timer as timer
import math
import cmath
import matplotlib.pyplot as plt
import mandelbrot2cython as mc


# GLOBAL variable
jet_vals = []

if __name__ == '__main__':
  w = 500
  h = 800
  max_iter = 500

  jet_vals = mc.create_jetcolorlist(jet_vals,max_iter)
  image = np.empty((w,h,4),np.float32)
  start = timer()
  # seahorse -.743,030, Im(c) = .126,433 diameter  .016,110
  xl,xu,yl,yu = [-0.743030-0.008055,-0.743030+0.008055, 0.126433-0.008055, 0.126433+0.008055]
  # standard
  #xl,xu,yl,yu = [-2.,1.,-1.0,1.0]
  #xl,xu,yl,yu = [-1.5,-0.5,-0.25,0.25]
  #xl,xu,yl,yu = [-1.3,-1.2,-0.15,0.0]
  mc.create_fractal(xl,xu,yl,yu, image, max_iter,jet_vals) 
  mc.create_fractal(xl,xu,yl,yu, image, max_iter,jet_vals) 
  dt = timer() - start
  print "Mandelbrot created in %f s" % dt
  ii=plt.imshow(image,interpolation='none', extent=[xl,xu,yl,yu],aspect='auto') 
  plt.show()

